AWSTemplateFormatVersion: '2010-09-09'
# Command: aws cloudformation create-stack --stack-name mylambdastack --template-body file://createLambda1.yml --capabilities CAPABILITY_NAMED_IAM
Description: This template creates 2 S3 buckets, role to access buckets and Lambda function to copy data between S3 buckets.
Parameters:
  SourceBucketName:
    Type: String
    Default: unique-bucket-name-unique-across-world-source # Unique bucket name across all AWS
  TargetBucketName:
    Type: String
    Default: unique-bucket-name-unique-across-world-target # Unique bucket name across all AWS
Resources:
  SourceBucket:
    Type: AWS::S3::Bucket
    Properties: 
      BucketName: !Ref SourceBucketName
      Tags:
      - Key: Name
        Value:  !Join ['', [!Ref "AWS::StackName", "-SourceBucket" ]]
      NotificationConfiguration: # Add a trigger, object created on S3
        LambdaConfigurations:
          - Event: 's3:ObjectCreated:*' # Trigger a function when an S3 object is created
            Function: !GetAtt Lambda.Arn  
  TargetBucket:
    Type: AWS::S3::Bucket
    Properties: 
      BucketName: !Ref TargetBucketName
      Tags:
      - Key: Name
        Value:  !Join ['', [!Ref "AWS::StackName", "-TargetBucket" ]]
      #NotificationConfiguration:
       # LambdaConfigurations:
        #  - Event: 's3:ObjectCreated:*' # Trigger a function when an S3 object is created
         #   Function: !GetAtt Lambda.Arn  
  Lambda: # Lambda Function to copy data from S3 to another S3
    Type: AWS::Lambda::Function
    Properties:
      Environment:
        Variables:
          DESTINATION_BUCKET: !Ref TargetBucketName
      Code:  # Python code to copy data to another S3. Assumption is the destination bucket is already created 
        ZipFile: |
         import json
         import boto3
         import os
         s3_client=boto3.client('s3')
         def lambda_handler(event, context):
            #specify source bucket
            source_bucket_name=event['Records'][0]['s3']['bucket']['name']
            #get object that has been uploaded
            file_name=event['Records'][0]['s3']['object']['key']
            #specify destination bucket
            #destination_bucket_name='mys3buckettoopens3'
            destination_bucket_name=os.environ['DESTINATION_BUCKET']
            #specify from where file needs to be copied
            copy_object={'Bucket':source_bucket_name,'Key':file_name}
            #write copy statement 
            s3_client.copy_object(CopySource=copy_object,Bucket=destination_bucket_name,Key=file_name)
            return {
                'statusCode': 3000,
                'body': json.dumps('File has been Successfully Copied')
            }
      #Role: arn:aws:iam::938536244682:role/ProvideS3FullAccess
      Role:
        Fn::GetAtt:
        - LambdaRole
        - Arn
      Runtime: python3.9
      Handler: index.lambda_handler #file name and method name 
      FunctionName: somelambdafunctionname #Function Name
  S3InvokeLambdaPermission: # Grants permission to AWS service to invoke Lambda
    Type: AWS::Lambda::Permission
    Properties:
      Action: lambda:InvokeFunction
      FunctionName: !Ref Lambda
      Principal: s3.amazonaws.com
      SourceArn: !Sub arn:aws:s3:::${SourceBucketName}
  LambdaRole:
    Type: AWS::IAM::Role
    Description: I am role added
    Properties:
      RoleName: !Join ['', ['customrole-', !Ref "AWS::Region", !Ref AWS::StackName ]]
      AssumeRolePolicyDocument:
        Version: '2012-10-17'
        Statement:
        - Effect: Allow
          Principal:
            Service: lambda.amazonaws.com
          Action:
          - sts:AssumeRole
      Path: '/'
      Policies:
      - PolicyName: s3
        PolicyDocument:
          Statement:
          - Effect: Allow
            Action:
              - s3:Get*
              - s3-object-lambda:*
              - s3:*
            Resource:
              - !Sub arn:aws:s3:::${SourceBucketName}
              - arn:aws:s3:::mys3buckettoopens3
              - '*'
              - !Sub arn:aws:s3:::${SourceBucketName}/*
      - PolicyName: AWSLambdaBasicExecutionRole
        PolicyDocument:
          Statement:
          - Effect: Allow
            Action:
            - logs:CreateLogGroup
            - logs:CreateLogStream
            - logs:PutLogEvents
            - logs:CreateLogStream
            - logs:PutLogEvents
            Resource: '*'
  RootInstanceProfile:
    Type: AWS::IAM::InstanceProfile
    Properties:
      Path: /
      Roles:
        - !Ref LambdaRole